package org.jastadd.ros2rag.tests;

import org.jastadd.relast.compiler.Compiler;
import org.jastadd.relast.compiler.options.CommandLine;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.nio.file.Paths;
import java.util.Objects;

import static org.junit.jupiter.api.Assertions.assertTrue;

public class RelAstTest {

  void transform(String inputDir, String outputDir) throws CommandLine.CommandLineException, Compiler.CompilerException {

    System.out.println("Running test in directory '" + Paths.get(".").toAbsolutePath() + "'.");
    assertTrue(Paths.get(inputDir).toFile().exists(), "input directory does not exist");
    assertTrue(Paths.get(inputDir).toFile().isDirectory(), "input directory is not a directory");

    File outputDirFile = Paths.get(outputDir).toFile();
    if (outputDirFile.exists()) {
      assertTrue(outputDirFile.isDirectory());
      if (Objects.requireNonNull(outputDirFile.list(), "Could not read output directory").length != 0) {
        System.out.println("output directory is not empty!");
      }
    } else {
      assertTrue(outputDirFile.mkdir());
    }

    String[] args = {
        "--outputDir=" + outputDir,
        "--inputDir=" + inputDir
    };

    new Compiler().run(args);
  }

  @Test
  void transformMinimalExample() throws CommandLine.CommandLineException, Compiler.CompilerException {
    transform("src/test/resources/in", "src/test/resources/out");
  }
}
